﻿using System;

namespace ID510678
{
	public static class DoubleUtil
	{
		internal const double DBL_EPSILON = 1.1102230246251568E-16;

		public static bool AreClose(double value1, double value2)
		{
			if (value1 == value2)
			{
				return true;
			}
			double num = ((Math.Abs(value1) + Math.Abs(value2)) + 10.0) * DBL_EPSILON;
			double num2 = value1 - value2;
			return ((-num < num2) && (num > num2));
		}

		public static bool GreaterThan(double value1, double value2)
		{
			return ((value1 > value2) && !AreClose(value1, value2));
		}

		public static bool LessThan(double value1, double value2)
		{
			return ((value1 < value2) && !AreClose(value1, value2));
		}
	}
}
