﻿using System;
using System.Linq;
using System.Windows.Controls;
using System.Windows.Input;
using Telerik.Windows.Controls;

namespace ID510678
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			this.InitializeComponent();
			this.AddHandler(RadSlider.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Slider_MouseLeftButtonDown), true);
		}

		private void Slider_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
		{
			var width = this.sldTimeSelection.ActualWidth;
			var mousePosition = e.GetPosition(this.sldTimeSelection);
			var value = ((this.sldTimeSelection.Maximum - this.sldTimeSelection.Minimum) * (mousePosition.X - width)) / width;
			this.sldTimeSelection.SelectionStart = this.SnapToTick(value);
		}

		private double SnapToTick(double value)
		{
			double minimum = this.sldTimeSelection.Minimum;
			double maximum = this.sldTimeSelection.Maximum;

			if (this.sldTimeSelection.TickFrequency > 0)
			{
				minimum = this.sldTimeSelection.Minimum + (Math.Round(((value - this.sldTimeSelection.Minimum) / this.sldTimeSelection.TickFrequency)) * this.sldTimeSelection.TickFrequency);
				maximum = Math.Min(this.sldTimeSelection.Maximum, minimum + this.sldTimeSelection.TickFrequency);
			}
			else if (this.sldTimeSelection.Ticks != null && this.sldTimeSelection.Ticks.Count > 0)
			{
				for (int i = 0; i < this.sldTimeSelection.Ticks.Count; i++)
				{
					double tickValue = this.sldTimeSelection.Ticks[i];
					if (DoubleUtil.AreClose(tickValue, value))
					{
						return value;
					}
					if (DoubleUtil.LessThan(tickValue, value) && DoubleUtil.GreaterThan(tickValue, minimum))
					{
						minimum = tickValue;
					}
					else if (DoubleUtil.GreaterThan(tickValue, value) && DoubleUtil.LessThan(tickValue, maximum))
					{
						maximum = tickValue;
					}
				}
			}

			value = DoubleUtil.GreaterThan(value, (minimum + maximum) * 0.5) ? maximum : minimum;

			return value;
		}
	}
}